--- old/usr/src/uts/common/os/streamio.c	2015-08-09 12:48:02.495236925 +0300
+++ new/usr/src/uts/common/os/streamio.c	2015-08-09 12:48:02.521613831 +0300
@@ -77,6 +77,7 @@
 #include <sys/dld.h>
 #include <sys/zone.h>
 #include <c2/audit.h>
+#include <sys/fcntl.h>
 
 /*
  * This define helps improve the readability of streams code while
@@ -5682,6 +5683,18 @@
 	case FIONBIO:
 	case FIOASYNC:
 		return (0);	/* handled by the upper layer */
+	case F_FORKED: {
+		if (crp != kcred)
+			return (-1);
+		sh_insert_pid(stp, (proc_t *)arg);
+		return (0);
+	}
+	case F_CLOSED: {
+		if (crp != kcred)
+			return (-1);
+		sh_remove_pid(stp, (proc_t *)arg);
+		return (0);
+	}
 	}
 }
 
